import serial
import time
from modbus_tk import modbus_rtu

"""
use modbus_tk control RLY-8
"""

# config master device
master = modbus_rtu.RtuMaster(serial.Serial(port="COM1", baudrate=115200, bytesize=8, parity='N', stopbits=1))
master.set_timeout(1.0)
master.set_verbose(True)

# use function_code 0x03 to read HOLDING_REGISTERS
relay_name = master.execute(1, 0x03, 0x30, 4, data_format='>BBBBBBBB')
print('relay_name:', relay_name)
print('name_to_char:', [chr(i) for i in relay_name[:7]])

# use function_code 0x01 & 0x05 to read and write COILS
while True:
    for i in range(8):
        relay_response = master.execute(1, 0x01, 0, 8)
        if relay_response[i] == 0:
            master.execute(1, 0x05, i, 1, 0xFF00)
            print('open relay No.%s success' % (i + 1))
            time.sleep(1)
        if relay_response[i] == 1:
            master.execute(1, 0x05, i, 1, 0x0000)
            print('close relay No.%s success' % (i + 1))
            time.sleep(1)
